package bagaturchess.learning.impl.eval.cfg;


public class WeightsBoardConfigImpl extends LearningBoardConfigImpl {
	
	
	public WeightsBoardConfigImpl() {
		super();
		
		MATERIAL_PAWN_O		=	Weights.MATERIAL_PAWN_O;
		MATERIAL_PAWN_E		=	Weights.MATERIAL_PAWN_E;
		MATERIAL_KNIGHT_O	=	Weights.MATERIAL_KNIGHT_O;
		MATERIAL_KNIGHT_E	=	Weights.MATERIAL_KNIGHT_E;
		MATERIAL_BISHOP_O	=	Weights.MATERIAL_BISHOP_O;
		MATERIAL_BISHOP_E	=	Weights.MATERIAL_BISHOP_E;
		MATERIAL_ROOK_O		=	Weights.MATERIAL_ROOK_O;
		MATERIAL_ROOK_E		=	Weights.MATERIAL_ROOK_E;
		MATERIAL_QUEEN_O	=	Weights.MATERIAL_QUEEN_O;
		MATERIAL_QUEEN_E	=	Weights.MATERIAL_QUEEN_E;
		
		MATERIAL_KING_O = 2000;
		MATERIAL_KING_E = 2000;
		
		MATERIAL_BARIER_NOPAWNS_O	= Math.max(MATERIAL_KNIGHT_O, MATERIAL_BISHOP_O) + MATERIAL_PAWN_O;
		MATERIAL_BARIER_NOPAWNS_E	= Math.max(MATERIAL_KNIGHT_E, MATERIAL_BISHOP_E) + MATERIAL_PAWN_E;
		
		multiply(PAWN_O, getWeight_PST_PAWN_O());
		multiply(PAWN_E, getWeight_PST_PAWN_E());
		multiply(KING_O, getWeight_PST_KING_O());
		multiply(KING_E, getWeight_PST_KING_E());
		multiply(KNIGHT_O, getWeight_PST_KNIGHT_O());
		multiply(KNIGHT_E, getWeight_PST_KNIGHT_E());
		multiply(BISHOP_O, getWeight_PST_BISHOP_O());
		multiply(BISHOP_E, getWeight_PST_BISHOP_E());
		multiply(ROOK_O, getWeight_PST_ROOK_O());
		multiply(ROOK_E, getWeight_PST_ROOK_E());
		multiply(QUEEN_O, getWeight_PST_QUEEN_O());
		multiply(QUEEN_E, getWeight_PST_QUEEN_E());

	}
	
	
	private static void multiply(double[] arr, double multiplier) {
		for (int i=0; i<arr.length; i++) {
			arr[i] = arr[i] * multiplier;
		}
	}
	
	
	@Override
	public double getWeight_PST_PAWN_O() {
		return Weights.PST_PAWN_O;
	}
	
	
	@Override
	public double getWeight_PST_PAWN_E() {
		return Weights.PST_PAWN_E;
	}
	
	
	@Override
	public double getWeight_PST_KING_O() {
		return Weights.PST_KING_O;
	}
	
	
	@Override
	public double getWeight_PST_KING_E() {
		return Weights.PST_KING_E;
	}
	
	
	@Override
	public double getWeight_PST_KNIGHT_O() {
		return Weights.PST_KNIGHTS_O;
	}
	
	
	@Override
	public double getWeight_PST_KNIGHT_E() {
		return Weights.PST_KNIGHTS_E;
	}
	
	
	@Override
	public double getWeight_PST_BISHOP_O() {
		return Weights.PST_BISHOPS_O;
	}
	
	
	@Override
	public double getWeight_PST_BISHOP_E() {
		return Weights.PST_BISHOPS_E;
	}
	
	
	@Override
	public double getWeight_PST_ROOK_O() {
		return Weights.PST_ROOKS_O;
	}
	
	
	@Override
	public double getWeight_PST_ROOK_E() {
		return Weights.PST_ROOKS_E;
	}
	
	
	@Override
	public double getWeight_PST_QUEEN_O() {
		return Weights.PST_QUEENS_O;
	}
	
	
	@Override
	public double getWeight_PST_QUEEN_E() {
		return Weights.PST_QUEENS_E;
	}
}
